"use strict";

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _loadFiles = _interopRequireDefault(require("jinghuan-helper/loadFiles"));

var _each = _interopRequireDefault(require("lodash/each"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const log = (0, _debug.default)(`JH:core/loader/controller[${process.pid}]`);

function closure(filepath) {
  return function () {
    return Promise.resolve(`${filepath}`).then(s => _interopRequireWildcard(require(s)));
  };
}

function load() {
  const cache = {};
  (0, _each.default)(jinghuanjs.modulePaths, (loadPath, module) => {
    if (module === 'common') return;
    cache[module] = {};

    let dir = _path.default.join(loadPath, 'controller');

    const files = (0, _loadFiles.default)(dir, ['js']);

    for (let name in files) {
      let filepath = files[name];
      log(`load file: ${filepath}`);
      Object.defineProperty(cache[module], name, {
        get: closure(filepath)
      });
    }
  });
  return cache;
}

;
module.exports = load;