"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _utils = require("../../utils");

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _isString = _interopRequireDefault(require("lodash/isString"));

var _store = _interopRequireDefault(require("../../store"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const RUN = Symbol('run');

function createRegexp(match) {
  if (match == null) return false;

  if ((0, _isFunction.default)(match)) {
    return match;
  }

  if (match) {
    return pathToRegexp(match);
  }
}

function checkMatch(match, ctx) {
  if (match == null) return false;

  if ((0, _isFunction.default)(match)) {
    return match(ctx);
  }

  return match.test(ctx.path);
}

function getMiddlewareFile(name) {
  let middleware = "";
  let appMid = (0, _utils.requireResolve)(_path.default.join(jinghuanjs.modulePaths['runtime'], 'middleware', name));
  let nodeMid = (0, _utils.requireResolve)('jinghuan-middleware-' + name);

  if (appMid) {
    middleware = appMid;
  } else if (nodeMid) {
    middleware = nodeMid;
  } else {
    throw new Error(`Middleware [${name}] failed to load`);
  }

  return middleware;
}

function parse(middlewares = []) {
  return middlewares.map(item => {
    if ((0, _isString.default)(item)) {
      return {
        handle: item,
        options: {}
      };
    }

    return item;
  }).map(item => {
    return async (ctx, next) => {
      let mfile = getMiddlewareFile(item.handle);

      if (!require.cache[mfile]) {
        const handle = await Promise.resolve(`${mfile}`).then(s => _interopRequireWildcard(require(s)));
        _store.default.middleware[mfile] = await (handle.default || handle)(item.options, jinghuanjs.app);
      }

      await _store.default.middleware[mfile](ctx, next);
    };
  });
}

function load() {
  let middlewares = jinghuanjs.config('middleware') || [];
  let ms = middlewares.map((v, k) => {
    return v.handle;
  });
  _store.default.koamid = ms;
  return parse(middlewares);
}

var _default = load;
exports.default = _default;
module.exports = exports.default;