"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _chokidar = _interopRequireDefault(require("chokidar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Watcher {
  constructor(options, cb) {
    this.options = options;
    this.cb = cb;
  }

  watch() {
    _chokidar.default.watch(this.options.paths, {
      ignoreInitial: true
    }).on('all', (event, file, stats) => {
      switch (event) {
        case 'change':
        case 'add':
        case 'addDir':
        case 'unlinkDir':
        case 'unlink':
          this.cb(_path.default.normalize(file));
          break;
      }
    });
  }

}

var _default = Watcher;
exports.default = _default;
module.exports = exports.default;