"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _jinghuanConfig = _interopRequireDefault(require("jinghuan-config"));

var _loader = _interopRequireDefault(require("./core/loader"));

var _cluster = _interopRequireDefault(require("cluster"));

var _koaCompose = _interopRequireDefault(require("koa-compose"));

var _utils = _interopRequireWildcard(require("./utils"));

var _each = _interopRequireDefault(require("lodash/each"));

var _get = _interopRequireDefault(require("lodash/get"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Loaders {
  constructor() {}

  loadMiddleware() {
    jinghuanjs.app.use((0, _koaCompose.default)(_loader.default.middleware()));
  }

  loadSocketIO() {
    let middleware = _loader.default.socketio();

    jinghuanjs.socketio.on('connect', client => {
      (0, _koaCompose.default)(middleware)(client);
    });
  }

  loadExtend() {
    let {
      ROOT_PATH,
      source
    } = jinghuanjs;

    let extend = _loader.default.extend(__dirname);

    let list = [['global', () => global], ['jinghuan', () => jinghuanjs], ['jinghuanjs', () => jinghuanjs], ['application', () => jinghuanjs.app], ['context', () => jinghuanjs.app.context]];
    list.forEach(([name, func]) => {
      if (!extend[name]) {
        return;
      }

      _utils.default.extend(func(), extend[name]);
    });
    extend = _loader.default.extend(_path.default.join(ROOT_PATH, source, 'runtime'));
    list.forEach(([name, func]) => {
      if (!extend[name]) {
        return;
      }

      _utils.default.extend(func(), extend[name]);
    });
  }

  loadConfig() {
    let {
      CONFIG_PATH
    } = jinghuanjs;
    (0, _utils.define)('config', (0, _jinghuanConfig.default)([_path.default.join(__dirname, 'config'), CONFIG_PATH]), jinghuanjs);
  }

  load() {
    this.loadExtend();
    this.loadConfig();
    this.loadMiddleware();
  }

}

;
var _default = Loaders;
exports.default = _default;
module.exports = exports.default;